package org.apache.maven.plugin.nar;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on maven-nar-plugin.<br/> Call <pre>  mvn nar:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Wed Nov 21 12:58:12 EST 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.6)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codeswarm:maven-nar-plugin:20121119", 0 );
        append( sb, "", 0 );

        append( sb, "Maven NAR Plugin", 0 );
        append( sb, "Third-party release of maven-nar-plugin:2.1-SNAPSHOT.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 20 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "nar:help", 0 );
            append( sb, "Display help information on maven-nar-plugin.\nCall\n\u00a0\u00a0mvn\u00a0nar:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-assembly".equals( goal ) )
        {
            append( sb, "nar:nar-assembly", 0 );
            append( sb, "Assemble libraries of NAR files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "classifiers", 2 );
                append( sb, "List of classifiers which you want to assemble. Example ppc-MacOSX-g++-static, x86-Windows-msvc-shared, i386-Linux-g++-executable, .... not setting means all.", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-compile".equals( goal ) )
        {
            append( sb, "nar:nar-compile", 0 );
            append( sb, "Compiles native source files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-download".equals( goal ) )
        {
            append( sb, "nar:nar-download", 0 );
            append( sb, "Downloads any dependent NAR files. This includes the noarch and aol type NAR files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "classifiers", 2 );
                append( sb, "List of classifiers which you want download. Example ppc-MacOSX-g++, x86-Windows-msvc, i386-Linux-g++.", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-gnu-configure".equals( goal ) )
        {
            append( sb, "nar:nar-gnu-configure", 0 );
            append( sb, "Copies the GNU style source files to a target area, autogens and configures them.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "gnuAutogenSkip (Default: false)", 2 );
                append( sb, "Skip running of autogen.sh (aka buildconf).", 3 );
                append( sb, "", 0 );

                append( sb, "gnuBuildconfArgs", 2 );
                append( sb, "Arguments to pass to GNU buildconf.", 3 );
                append( sb, "", 0 );

                append( sb, "gnuConfigureArgs", 2 );
                append( sb, "Arguments to pass to GNU configure.", 3 );
                append( sb, "", 0 );

                append( sb, "gnuConfigureSkip (Default: false)", 2 );
                append( sb, "Skip running of configure and therefore also autogen.sh", 3 );
                append( sb, "", 0 );

                append( sb, "gnuSourceDirectory", 2 );
                append( sb, "Source directory for GNU style project", 3 );
                append( sb, "", 0 );

                append( sb, "gnuTargetDirectory", 2 );
                append( sb, "Directory in which gnu sources are copied and \'configured\'", 3 );
                append( sb, "", 0 );

                append( sb, "gnuUseOnWindows (Default: false)", 2 );
                append( sb, "Use GNU goals on Windows", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "resourceBinDir", 2 );
                append( sb, "Binary directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourceIncludeDir", 2 );
                append( sb, "Include directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourceLibDir", 2 );
                append( sb, "Library directory", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-gnu-make".equals( goal ) )
        {
            append( sb, "nar:nar-gnu-make", 0 );
            append( sb, "Runs make on the GNU style generated Makefile", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "gnuMakeArgs", 2 );
                append( sb, "Space delimited list of arguments to pass to make", 3 );
                append( sb, "", 0 );

                append( sb, "gnuMakeEnv", 2 );
                append( sb, "Comma delimited list of environment variables to setup before running make", 3 );
                append( sb, "", 0 );

                append( sb, "gnuMakeInstallSkip (Default: false)", 2 );
                append( sb, "Boolean to control if we should skip \'make install\' after the make", 3 );
                append( sb, "", 0 );

                append( sb, "gnuSourceDirectory", 2 );
                append( sb, "Source directory for GNU style project", 3 );
                append( sb, "", 0 );

                append( sb, "gnuTargetDirectory", 2 );
                append( sb, "Directory in which gnu sources are copied and \'configured\'", 3 );
                append( sb, "", 0 );

                append( sb, "gnuUseOnWindows (Default: false)", 2 );
                append( sb, "Use GNU goals on Windows", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "resourceBinDir", 2 );
                append( sb, "Binary directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourceIncludeDir", 2 );
                append( sb, "Include directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourceLibDir", 2 );
                append( sb, "Library directory", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-gnu-process".equals( goal ) )
        {
            append( sb, "nar:nar-gnu-process", 0 );
            append( sb, "Move the GNU style output in the correct directories for nar-package", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "gnuSourceDirectory", 2 );
                append( sb, "Source directory for GNU style project", 3 );
                append( sb, "", 0 );

                append( sb, "gnuTargetDirectory", 2 );
                append( sb, "Directory in which gnu sources are copied and \'configured\'", 3 );
                append( sb, "", 0 );

                append( sb, "gnuUseOnWindows (Default: false)", 2 );
                append( sb, "Use GNU goals on Windows", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "resourceBinDir", 2 );
                append( sb, "Binary directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourceIncludeDir", 2 );
                append( sb, "Include directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourceLibDir", 2 );
                append( sb, "Library directory", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-gnu-resources".equals( goal ) )
        {
            append( sb, "nar:nar-gnu-resources", 0 );
            append( sb, "Move the GNU style include/lib to some output directory", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "gnuSourceDirectory", 2 );
                append( sb, "Source directory for GNU style project", 3 );
                append( sb, "", 0 );

                append( sb, "gnuTargetDirectory", 2 );
                append( sb, "Directory in which gnu sources are copied and \'configured\'", 3 );
                append( sb, "", 0 );

                append( sb, "gnuUseOnWindows (Default: false)", 2 );
                append( sb, "Use GNU goals on Windows", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "resourceBinDir", 2 );
                append( sb, "Binary directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourceIncludeDir", 2 );
                append( sb, "Include directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourceLibDir", 2 );
                append( sb, "Library directory", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-integration-test".equals( goal ) )
        {
            append( sb, "nar:nar-integration-test", 0 );
            append( sb, "Run integration tests using Surefire. This goal was copied from Maven\'s surefire plugin to accomodate a few things for the NAR plugin:\n1. To test a jar file with its native module we can only run after the package phase, so we use the integration-test phase.\n\n2. We need to set java.library.path to an AOL (architecture-os-linker) specific value, but AOL is only known in the NAR plugin and thus cannot be set from the pom.\n\n3. To have the java.library.path definition picked up by java we need the \'pertest\' forkmode. To use this goal you need to put the test sources in the regular test directories but disable the running of the tests by the maven-surefire-plugin by setting maven.test.skip.exec to false in your pom.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "additionalClasspathElements", 2 );
                append( sb, "Additional elements to be appended to the classpath.", 3 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "argLine", 2 );
                append( sb, "Arbitrary JVM options to set on the command line.", 3 );
                append( sb, "", 0 );

                append( sb, "basedir", 2 );
                append( sb, "The base directory of the project being tested. This can be obtained in your unit test by System.getProperty(\'basedir\').", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "childDelegation (Default: false)", 2 );
                append( sb, "When false it makes tests run using the standard classloader delegation instead of the default Maven isolated classloader. Only used when forking (forkMode is not \'none\').\nSetting it to false helps with some problems caused by conflicts between xml parsers in the classpath and the Java 5 provider parser.", 3 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "The directory containing generated classes of the project being tested.", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "debugForkedProcess", 2 );
                append( sb, "Attach a debugger to the forked JVM. If set to \'true\', the process will suspend and wait for a debugger to attach on port 5005. If set to some other string, that string will be appended to the argLine, allowing you to configure arbitrary debuggability options (without overwriting the other options specified in the argLine).", 3 );
                append( sb, "", 0 );

                append( sb, "disableXmlReport (Default: false)", 2 );
                append( sb, "Flag to disable the generation of report files in xml format.", 3 );
                append( sb, "", 0 );

                append( sb, "enableAssertions (Default: true)", 2 );
                append( sb, "By default, Surefire enables JVM assertions for the execution of your test cases. To disable the assertions, set this flag to false.", 3 );
                append( sb, "", 0 );

                append( sb, "environmentVariables", 2 );
                append( sb, "Additional environments to set on the command line.", 3 );
                append( sb, "", 0 );

                append( sb, "excludedGroups", 2 );
                append( sb, "(TestNG only) Excluded groups. Any methods/classes/etc with one of the groups specified in this list will specifically not be run. This parameter is overridden if suiteXmlFiles are specified.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "List of patterns (separated by commas) used to specify the tests that should be excluded in testing. When not specified and when the test parameter is not specified, the default excludes will be **/*$* (which excludes all inner classes). This parameter is ignored if TestNG suiteXmlFiles are specified.", 3 );
                append( sb, "", 0 );

                append( sb, "failIfNoTests", 2 );
                append( sb, "Set this to \'true\' to cause a failure if there are no tests to run. Defaults to false.", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "forkedProcessTimeoutInSeconds", 2 );
                append( sb, "Kill the forked test process after a certain number of seconds. If set to 0, wait forever for the process, never timing out.", 3 );
                append( sb, "", 0 );

                append( sb, "forkMode (Default: once)", 2 );
                append( sb, "Option to specify the forking mode. Can be \'never\', \'once\' or \'always\'. \'none\' and \'pertest\' are also accepted for backwards compatibility.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "groups", 2 );
                append( sb, "(TestNG only) Groups for this test. Only classes/methods/etc decorated with one of the groups specified here will be included in test run, if specified. This parameter is overridden if suiteXmlFiles are specified.", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "includes", 2 );
                append( sb, "List of patterns (separated by commas) used to specify the tests that should be included in testing. When not specified and when the test parameter is not specified, the default includes will be **/Test*.java **/*Test.java **/*TestCase.java. This parameter is ignored if TestNG suiteXmlFiles are specified.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "junitArtifactName (Default: junit:junit)", 2 );
                append( sb, "Allows you to specify the name of the JUnit artifact. If not set, junit:junit will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "jvm", 2 );
                append( sb, "Option to specify the jvm (or path to the java executable) to use with the forking options. For the default, the jvm will be the same as the one used to run Maven.", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "parallel", 2 );
                append( sb, "(TestNG only) When you use the parallel attribute, TestNG will try to run all your test methods in separate threads, except for methods that depend on each other, which will be run in the same thread in order to respect their order of execution.", 3 );
                append( sb, "", 0 );

                append( sb, "printSummary (Default: true)", 2 );
                append( sb, "Option to print summary of test suites or just print the test cases that has errors.", 3 );
                append( sb, "", 0 );

                append( sb, "properties", 2 );
                append( sb, "List of properties for configuring all TestNG related configurations. This is the new preferred method of configuring TestNG.", 3 );
                append( sb, "", 0 );

                append( sb, "redirectTestOutputToFile (Default: false)", 2 );
                append( sb, "When forking, set this to true to redirect the unit test standard output to a file (found in reportsDirectory/testName-output.txt).", 3 );
                append( sb, "", 0 );

                append( sb, "remoteRepositories", 2 );
                append( sb, "The plugin remote repositories declared in the pom.", 3 );
                append( sb, "", 0 );

                append( sb, "reportFormat (Default: brief)", 2 );
                append( sb, "Selects the formatting for the test report to be generated. Can be set as brief or plain.", 3 );
                append( sb, "", 0 );

                append( sb, "reportsDirectory", 2 );
                append( sb, "Base directory where all reports are written to.", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "skipNar (Default: false)", 2 );
                append( sb, "Skip running of NAR integration test plugin", 3 );
                append( sb, "", 0 );

                append( sb, "skipNarExec", 2 );
                append( sb, "DEPRECATED This old parameter is just like skipTests, but bound to the old property maven.test.skip.exec. Use -DskipTests instead; it\'s shorter.", 3 );
                append( sb, "", 0 );

                append( sb, "skipNarTests", 2 );
                append( sb, "Set this to \'true\' to skip running tests, but still compile them. Its use is NOT RECOMMENDED, but quite convenient on occasion.", 3 );
                append( sb, "", 0 );

                append( sb, "suiteXmlFiles", 2 );
                append( sb, "(TestNG only) List of TestNG suite xml file locations, seperated by commas. Note that suiteXmlFiles is incompatible with several other parameters on this plugin, like includes/excludes. This parameter is ignored if the \'test\' parameter is specified (allowing you to run a single test instead of an entire suite).", 3 );
                append( sb, "", 0 );

                append( sb, "systemProperties", 2 );
                append( sb, "List of System properties to pass to the JUnit tests.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "test", 2 );
                append( sb, "Specify this parameter to run individual tests by file name, overriding the includes/excludes parameters. Each pattern you specify here will be used to create an include pattern formatted like **/${test}.java, so you can just type \'-Dtest=MyTest\' to run a single test called \'foo/MyTest.java\'. This parameter will override the TestNG suiteXmlFiles parameter.", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "The directory containing generated test classes of the project being tested.", 3 );
                append( sb, "", 0 );

                append( sb, "testFailureIgnore", 2 );
                append( sb, "Set this to true to ignore a failure during testing. Its use is NOT RECOMMENDED, but quite convenient on occasion.", 3 );
                append( sb, "", 0 );

                append( sb, "testNGArtifactName (Default: org.testng:testng)", 2 );
                append( sb, "Allows you to specify the name of the TestNG artifact. If not set, org.testng:testng will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory", 2 );
                append( sb, "The test source directory containing test class sources.", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "threadCount", 2 );
                append( sb, "(TestNG only) The attribute thread-count allows you to specify how many threads should be allocated for this execution. Only makes sense to use in conjunction with parallel.", 3 );
                append( sb, "", 0 );

                append( sb, "trimStackTrace (Default: true)", 2 );
                append( sb, "Whether to trim the stack trace in the reports to just the lines within the test, or show the full trace.", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "useFile (Default: true)", 2 );
                append( sb, "Option to generate a file test report or just output the test report to the console.", 3 );
                append( sb, "", 0 );

                append( sb, "useManifestOnlyJar (Default: true)", 2 );
                append( sb, "By default, Surefire forks your tests using a manifest-only jar; set this parameter to \'false\' to force it to launch your tests with a plain old Java classpath. (See http://maven.apache.org/plugins/maven-surefire-plugin/examples/class-loading.html for a more detailed explanation of manifest-only jars and their benefits.) Default value is \'true\'. Beware, setting this to \'false\' may cause your tests to fail on Windows if your classpath is too long.", 3 );
                append( sb, "", 0 );

                append( sb, "useSystemClassLoader", 2 );
                append( sb, "Option to pass dependencies to the system\'s classloader instead of using an isolated class loader when forking. Prevents problems with JDKs which implement the service provider lookup mechanism by using the system\'s classloader. Default value is \'true\'.", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory", 2 );
                append( sb, "Command line working directory.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-javah".equals( goal ) )
        {
            append( sb, "nar:nar-javah", 0 );
            append( sb, "Compiles class files into c/c++ headers using \'javah\'. Any class file that contains methods that were declared \'native\' will be run through javah.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-package".equals( goal ) )
        {
            append( sb, "nar:nar-package", 0 );
            append( sb, "Jars up the NAR files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-resources".equals( goal ) )
        {
            append( sb, "nar:nar-resources", 0 );
            append( sb, "Copies any resources, including AOL specific distributions, to the target area for packaging", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "resourceBinDir", 2 );
                append( sb, "Binary directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory", 2 );
                append( sb, "Directory for nar resources. Defaults to src/nar/resources", 3 );
                append( sb, "", 0 );

                append( sb, "resourceIncludeDir", 2 );
                append( sb, "Include directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourceLibDir", 2 );
                append( sb, "Library directory", 3 );
                append( sb, "", 0 );

                append( sb, "resourcesCopyAOL (Default: true)", 2 );
                append( sb, "Use given AOL only. If false, copy for all available AOLs.", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-system-generate".equals( goal ) )
        {
            append( sb, "nar:nar-system-generate", 0 );
            append( sb, "Generates a NarSystem class with static methods to use inside the java part of the library. Runs in generate-resources rather than generate-sources to allow the maven-swig-plugin (which runs in generate-sources) to configure the nar plugin and to let it generate a proper system file.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-test".equals( goal ) )
        {
            append( sb, "nar:nar-test", 0 );
            append( sb, "Tests NAR files. Runs Native Tests and executables if produced.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-testCompile".equals( goal ) )
        {
            append( sb, "nar:nar-testCompile", 0 );
            append( sb, "Compiles native test source files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "skipNar (Default: false)", 2 );
                append( sb, "Skip running of NAR integration test plugins.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-testDownload".equals( goal ) )
        {
            append( sb, "nar:nar-testDownload", 0 );
            append( sb, "Downloads any dependent NAR files. This includes the noarch and aol type NAR files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "classifiers", 2 );
                append( sb, "List of classifiers which you want download. Example ppc-MacOSX-g++, x86-Windows-msvc, i386-Linux-g++.", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-testUnpack".equals( goal ) )
        {
            append( sb, "nar:nar-testUnpack", 0 );
            append( sb, "Unpacks NAR files. Unpacking happens in the local repository, and also sets flags on binaries and corrects static libraries.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "classifiers", 2 );
                append( sb, "List of classifiers which you want unpack. Example ppc-MacOSX-g++, x86-Windows-msvc, i386-Linux-g++.", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-unpack".equals( goal ) )
        {
            append( sb, "nar:nar-unpack", 0 );
            append( sb, "Unpacks NAR files. Unpacking happens in the local repository, and also sets flags on binaries and corrects static libraries.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "classifiers", 2 );
                append( sb, "List of classifiers which you want unpack. Example ppc-MacOSX-g++, x86-Windows-msvc, i386-Linux-g++.", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-validate".equals( goal ) )
        {
            append( sb, "nar:nar-validate", 0 );
            append( sb, "Validates the configuration of the NAR project (aol and pom)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "nar-vcproj".equals( goal ) )
        {
            append( sb, "nar:nar-vcproj", 0 );
            append( sb, "Generates a Visual Studio 2005 project file (vcproj) Heavily inspired by NarCompileMojo.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aol", 2 );
                append( sb, "Architecture-OS-Linker name. Defaults to: arch-os-linker.", 3 );
                append( sb, "", 0 );

                append( sb, "architecture", 2 );
                append( sb, "The Architecture for the nar, Some choices are: \'x86\', \'i386\', \'amd64\', \'ppc\', \'sparc\', ... Defaults to a derived value from ${os.arch}", 3 );
                append( sb, "", 0 );

                append( sb, "c", 2 );
                append( sb, "C Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "cpp", 2 );
                append( sb, "C++ Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: true)", 2 );
                append( sb, "Fail on compilation/linking error.", 3 );
                append( sb, "", 0 );

                append( sb, "fortran", 2 );
                append( sb, "Fortran Compiler", 3 );
                append( sb, "", 0 );

                append( sb, "ignore (Default: false)", 2 );
                append( sb, "Ignore errors and failures.", 3 );
                append( sb, "", 0 );

                append( sb, "java", 2 );
                append( sb, "Java info for includes and linking", 3 );
                append( sb, "", 0 );

                append( sb, "javah", 2 );
                append( sb, "Javah info", 3 );
                append( sb, "", 0 );

                append( sb, "layout (Default: org.apache.maven.plugin.nar.NarLayout21)", 2 );
                append( sb, "Layout to be used for building and unpacking artifacts", 3 );
                append( sb, "", 0 );

                append( sb, "libraries", 2 );
                append( sb, "List of libraries to create", 3 );
                append( sb, "", 0 );

                append( sb, "libtool (Default: false)", 2 );
                append( sb, "Set use of libtool. If set to true, the \'libtool \' will be prepended to the command line for compatible processors.", 3 );
                append( sb, "", 0 );

                append( sb, "linker", 2 );
                append( sb, "Linker", 3 );
                append( sb, "", 0 );

                append( sb, "maxCores", 2 );
                append( sb, "Maximum number of Cores/CPU\'s to use. 0 means unlimited.", 3 );
                append( sb, "", 0 );

                append( sb, "os", 2 );
                append( sb, "The Operating System for the nar. Some choices are: \'Windows\', \'Linux\', \'MacOSX\', \'SunOS\', ... Defaults to a derived value from ${os.name} FIXME table missing", 3 );
                append( sb, "", 0 );

                append( sb, "output", 2 );
                append( sb, "Name of the output", 3 );
                append( sb, "", 0 );

                append( sb, "runtime (Default: dynamic)", 2 );
                append( sb, "Sets the type of runtime library, possible values \'dynamic\', \'static\'.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Skip running of NAR plugins (any) altogether.", 3 );
                append( sb, "", 0 );

                append( sb, "targetDirectory", 2 );
                append( sb, "Target directory for Nar file construction. Defaults to \'${project.build.directory}/nar\' for \'nar-compile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "tests", 2 );
                append( sb, "List of tests to create", 3 );
                append( sb, "", 0 );

                append( sb, "testTargetDirectory", 2 );
                append( sb, "Target directory for Nar test construction. Defaults to \'${project.build.directory}/test-nar\' for \'nar-testCompile\' goal", 3 );
                append( sb, "", 0 );

                append( sb, "testUnpackDirectory", 2 );
                append( sb, "Target directory for Nar test unpacking. Defaults to \'${testTargetDirectory}\'", 3 );
                append( sb, "", 0 );

                append( sb, "unpackDirectory", 2 );
                append( sb, "Target directory for Nar file unpacking. Defaults to \'${targetDirectory}\'", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
